'
' TrashConfig VB Script
'
' Copyright 2014 RF MasterX
'
' This script is free for noncommercial use, it is
' WITHOUT ANY WARRANTY; without even implied warranty of fitness for a particular purpose!
'
' You can redistribute it only in original unmodified form!
' 

const HKLM = &H80000002
strPrgInfo = "PurgeInfo"
strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\explorer\BitBucket"
strRegProv = "winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv"

bDefaultPurgeInfoBytes = Array(&H48, &H00, &H00, &H00, &H01, &H00, &H00, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H0A, &H00, &H00, &H00, &H00, &H00, &H68, &H4E, &HF5, &HBF)

Dim bPurgeInfoBytes(71)

      Set oReg = GetObject(strRegProv)
      Call Main


Function TryGetPurgeInfo()
      TryGetPurgeInfo = oReg.GetBinaryValue(HKLM, strKeyPath, strPrgInfo, bPurgeInfoBytes)
End Function


Function TrySetPurgeInfo(swt)
      If swt Then
         TrySetPurgeInfo = oReg.SetBinaryValue(HKLM, strKeyPath, strPrgInfo, bPurgeInfoBytes)
      Else
         TrySetPurgeInfo = oReg.SetBinaryValue(HKLM, strKeyPath, strPrgInfo, bDefaultPurgeInfoBytes)
      End If
End Function


Sub SetBit(nByte, nBit)
      bMask = 2 ^ nBit
      nByte = nByte Or bMask
End Sub


Function SetBits(bPiBuffer, strDriveLetter)
      blnRetVal = False
      iDrv = Asc(UCase(strDriveLetter)) - 65
      bPiBuffer(4) = 0

      If (iDrv >= 0) And (iDrv <= 7) then
            Call SetBit(bPiBuffer(64), iDrv) : blnRetVal = True
      End If
      If (iDrv >= 8) And (iDrv <= 15) then
            Call SetBit(bPiBuffer(65), iDrv - 8) : blnRetVal = True
      End If
      If (iDrv >= 16) And (iDrv <= 23) then
            Call SetBit(bPiBuffer(66), iDrv - 16) : blnRetVal = True
      End If
      If (iDrv >= 24) And (iDrv <= 25) then
            Call SetBit(bPiBuffer(67), iDrv - 24) : blnRetVal = True
      End If
      SetBits = blnRetVal
End Function


Function ChangeConfig(strDriveLetter, swt)
      If swt Then 
         ChangeConfig = SetBits(bPurgeInfoBytes, strDriveLetter)
      Else
         ChangeConfig = SetBits(bDefaultPurgeInfoBytes, strDriveLetter)
      End If
End Function


Function InputBox2()
      strRetVal = InputBox("Disable 'Move files to Recycle Bin' for selected drive(s)" & vbCrLf & vbCrLf & "Enter drive letter(s)" & vbCrLf & vbCrLf & "e.g.-> c" & vbCrLf & "or" & vbCrLf & "e.g.-> c,d,e" )
      if Len(strRetVal) > 0 Then InputBox2 = strRetVal else InputBox2 = ""
End Function


Sub Main()
      Dim blnUseDefPI, arrStr, strTemp

      If TryGetPurgeInfo() Then blnUseDefPI = False Else blnUseDefPI = True
      
      strTemp = InputBox2()

      If Len(strTemp) = 0 Then
       While Len(strTemp) = 0
        If MsgBox("Enter drive letter!", vbRetryCancel, "Error") = vbRetry Then
           strTemp = InputBox2()
        Else
           Exit Sub
        End If
       Wend
      End If

      If (Len(strTemp) = 1) Then
       If (Asc(UCase(strTemp)) >= 65) And (Asc(UCase(strTemp)) <= 90) Then
          ChangeConfig strTemp, blnUseDefPI
       Else
          MsgBox "Wrong drive letter!", vbCritical, "Error!"
          Exit Sub
       End If
       TrySetPurgeInfo blnUseDefPI
      End If

      If Len(strTemp) >= 2 Then
       arrStr = Split(strTemp, ",")

       For j = 0 To Ubound(arrStr)
         If (Asc(UCase(strTemp)) >= 65) And (Asc(UCase(strTemp)) <= 90) Then
            ChangeConfig arrStr(j), blnUseDefPI
         Else
            MsgBox "Wrong drive letter!", vbCritical, "Error!"
            Exit Sub
         End If
       Next
       TrySetPurgeInfo blnUseDefPI
      End If

      MsgBox "Settings successfully changed!", vbInformation, "Success!"
End Sub











